// JavaScript Document
//tablica
var koszykXmlHttpRequest = createXmlHttpRequestObject();
var PHPSESSID = '';

function do_koszyka(towar_id, numer){

    var ilosc = parseFloat(document.forms['towary']['do_koszyka'+numer].value.replace(',', '.') );
    if(isNaN(ilosc)){
        alert('Ilo dodawanego towaru musi byc liczb.');
        return false;
    }

    if( ilosc <= 0 ){
        alert('Ilo dodawanego towaru musi by wiksza od zera.');
        return false;
    }

    //jesli AJAX dziaa no to bedzie dodawanie bez przeadowania
    if(koszykXmlHttpRequest){
        try
        {
          /* jeli obiekt XMLHttpRequest nie jest zajty obsug poprzedniego dnia... */
          if ( koszykXmlHttpRequest.readyState == 4 || koszykXmlHttpRequest.readyState == 0 ){
            koszykXmlHttpRequest.open("GET", MAIN_URL + '?action=koszyk&mode=dodaj&ajax=1&ID=' + towar_id + '&SZT=' + ilosc, true);
            koszykXmlHttpRequest.onreadystatechange = handleKoszykResponse;
            koszykXmlHttpRequest.send(null);
          }else{// jeli jest zajty...
            // ponawia prb po 0.5 sekundy
            setTimeout( function(){
                do_koszyka(towar_id, numer);
                }, 500);
          }
        }catch(e){
          //alert("Nie mog poczy si z serwerem:\n" + e.toString());
          window.location = MAIN_URL + '?action=koszyk&mode=dodaj&ID=' + towar_id + '&SZT=' + ilosc;
        }
    }else{
        //w przciwnym razie zmieniamy adres przegladarki
        window.location = MAIN_URL + '?action=koszyk&mode=dodaj&ID=' + towar_id + '&SZT=' + ilosc;
    }
}

function handleKoszykResponse(){
  //po ukoczeniu procesu, decyduje co zrobi z otrzymanymi danymi
  if (koszykXmlHttpRequest.readyState == 4)
  {
    // tylko jeli status dania HTTP jest "OK"
    if ( koszykXmlHttpRequest.status == 200)
    {
      try{
        // przetwarza odpowied serwera
        // pobiera element dokumentu
        var xmlRoot = koszykXmlHttpRequest.responseXML.documentElement;
        var response = xmlRoot.getElementsByTagName('odpowiedz').item(0);
        
        var dodano = parseInt(response.getAttribute('dodano'));
        var towar_nazwa = response.getAttribute('nazwa');
        
        if(dodano > 0){
            var lp = parseInt(response.getAttribute('liczba_poz'));
            var wn = parseFloat(response.getAttribute('wartosc_netto'));
            var wb = parseFloat(response.getAttribute('wartosc_brutto'));
            //aktualizuje stan koszyka
            update_stan_koszyka(lp, wn, wb);

            alert('Towar: ' + towar_nazwa + ' zosta pomylnie dodany do koszyka!');
        }else{
            var blad = response.getAttribute('error');
            alert('Nie dodano towaru do koszyka! \n' + blad);
        }
        
      }catch(e){
          // wywietla komunikat o bdzie
          alert( e.toString() );
      }
    }else{
        alert("Wystpi problem podczas pobierania danych:\n" + koszykXmlHttpRequest.statusText);
    }
  }

}

function update_stan_koszyka(liczba_poz, wartosc_netto, wartosc_brutto){
  var lp_el = document.getElementById('koszyk_liczba_poz');
  if( !lp_el ){
    //alert('Nie znalazeem elementu koszyk_liczba_poz');
    return false;
  }
  //pozostaych elementw nie sprawdzam poniewaz jesli nie ma pierwszego to
  //koszyk_wartosc_netto i koszyk_wartosc_brutto nie wystapia, bo albo nie dziaa
  //metod dokumentu getElementById albo nie ma ich w dokumencie
  var wn_el = document.getElementById('koszyk_wartosc_netto');
  var wb_el = document.getElementById('koszyk_wartosc_brutto');

  liczba_poz = parseInt(liczba_poz);


  lp_el.innerHTML = '<b>' + liczba_poz + '</b>';
  wn_el.innerHTML = '<b>' + currency_format( wartosc_netto ) + '</b>';
  wb_el.innerHTML = '<b>' + currency_format( wartosc_brutto ) + '</b>';
}



var o_koszyk_load_div = null;
var o_koszyk_save_div = null;

function show_koszyk_save_form(){

    showTlo();

    if( !o_koszyk_save_div ) o_koszyk_save_div = document.getElementById('koszyk_save_div');

    center_both_obj(o_koszyk_save_div);

    var f = document.forms['koszyk_save_form'];
    
    //f.koszyk_nazwa.focus();

}


function anuluj_koszyk_save_form(){
    var f = document.forms['koszyk_save_form'];
    
    hide_obj(o_koszyk_save_div);

    hideTlo();
}

function koszyk_save_form_check(o_form){
    if( arguments.length == 0 ){
        o_form = document.forms['koszyk_save_form'];
    }
    
    if( !( parseInt(o_form.koszyk_id.value) > 0) && o_form.koszyk_nazwa.value == '' ){
        alert('Wpisz nazw pod ktr ma zosta zapisana zawrto koszyka lub wybierz ju istniejcy koszyk!');
        return false;
    }

    return true;
    
}



function show_koszyk_load_form(){

    showTlo();

    if( !o_koszyk_load_div ) o_koszyk_load_div = document.getElementById('koszyk_load_div');

    center_both_obj(o_koszyk_load_div);

    var f = document.forms['koszyk_load_form'];

}


function anuluj_koszyk_load_form(){

    var f = document.forms['koszyk_load_form'];

    hide_obj(o_koszyk_load_div);

    hideTlo();
}

function koszyk_load_form_check(o_form){
    if( arguments.length == 0 ){
        o_form = document.forms['koszyk_load_form'];
    }

    if( !(o_form.koszyk_id.value > 0)  ){
        alert('Wybierz koszyk ktrego zawarto chcesz wczyta!');
        return false;
    }

    return true;
}

function koszyk_ondelete(){
    var o_form = document.forms['koszyk_load_form'];

    if( o_form.koszyk_id.value > 0 ){
        if(confirm('Potwierd usuwanie koszyka'))
            window.location = MAIN_URL + '?action=koszyk&mode=delete&koszyk_id='+o_form.koszyk_id.value;
    }else{
      alert('Wybierz koszyk ktry chcesz usun!');
    }
    
}
