var passMeterTitle = "Miernik jakoci hasa";
var passMeterDescr = new Array('wprowadz haso', 'bardzo sabe', 'sabe', 'umiarkowane', 'silne', 'bardzo silne');

function PassMeter(field, title, levelDescr) {
		if ( !field ){
        return false;
    }

		this.field = field;
		this.title = title;
		this.levelDescr = levelDescr;

		this.lMain;
		this.lLog;
		this.log = new Array();
		this.points = 0;
		this.level = 0;
		this.levelMax = 5;

    var o_self = this;
    
    if( field.addEventListener ){
        field.addEventListener('keyup', function(e){o_self.show() }, true);
    		field.addEventListener('focus', function(e){o_self.show() }, true);
    		field.addEventListener('blur', function(e){ o_self.hide() }, true);
    }else if( field.attachEvent ){
        field.attachEvent('onkeyup', function(e){ o_self.show(e) });
        field.attachEvent('onfocus', function(e){ o_self.show(e) });
        field.attachEvent('onblur', function(e){o_self.hide(e) } );
    }
    
}

PassMeter.prototype.create = function() {
    
    
		this.lMain = document.createElement ('div');
		this.lMain.id = 'passMeter';

    this.lMain.className = 'passMeter';

    this.lMain.style.position = 'absolute';
    this.lMain.style.marginTop = '-59px';
    
		this.lMain.innerHTML = '<div style="font-weight:bold;">'+this.title+':</div>'
			+ '<div></div>'
			+ '<div style="width:150px; height:5px; font-size:1px; line-height:1px; background:#D0D0D0; margin-top:5px; overflow: hidden;"></div>';
		this.field.parentNode.insertBefore(this.lMain, this.field);

		// PROGRESS TAB
		// rysowanie tabeli progresu
		var tab = document.createElement ('table'),
			tbody = document.createElement ('tbody'),
			row = document.createElement ('tr'),
			cell = document.createElement ('td'),
			i, cellClone;
		tab.cellPadding = 0;
		tab.cellSpacing = 0;
		
		tab.style.width = '100%';
		tab.style.height = '5px';
		tab.style.fontSize = '1px';
		tab.style.lineHeight = '1px';

		cell.style.borderRight = '3px #FFFFFF solid';
		
		cell.innerHTML = '&nbsp;';
		for (i=0; i<this.levelMax; i++) {
			cellClone = cell.cloneNode(true);
			row.appendChild (cellClone);
		}
		tbody.appendChild (row);
		tab.appendChild (tbody);
		this.lMain.childNodes[2].appendChild (tab);
}


PassMeter.prototype.show = function () {
		this.count();

		if (!this.lMain) this.create();
		
		this.lMain.style.display = '';

		if (this.levelDescr && this.levelDescr[this.level])
			this.lMain.childNodes[1].innerHTML = this.levelDescr[this.level];

		var row = this.lMain.childNodes[2].childNodes[0].childNodes[0].childNodes[0],	i;
		
		for (i = 0; i < this.levelMax; i++ ) {
        row.childNodes[i].style.visibility = (i > this.level-1 ? 'hidden' : '' );
        row.childNodes[i].style.background = (i > this.level ? '' :
        		(this.level >= this.levelMax-1 ? '#00D500' :	(this.level >= 3 ? '#FF8E28' : 'red')));
		}
}


PassMeter.prototype.hide = function () {
    this.lMain.style.display = 'none';
}


PassMeter.prototype.count = function () {
		var pass = this.field.value;

		this.log = new Array()
		this.points = 0;
		this.level = 0;

		// POWTARZAJACE SIE ZNAKI
		pass = pass.replace (/(.)\1+/g, '$1');

		// DLUGOSC HASLA
		if (!pass.length)  {
			this.points = -1;
		} else if (pass.length<4) {
			this.points += 3;
		} else if (pass.length<6) {
			this.points += 8;
		} else if (pass.length<12) {
			this.points += 12;
		} else {
			this.points += 18;
		}

		var digCnt 	= pass.match (/\d/g),
			lcCnt 	= pass.match (/[a-z]/g),
			ucCnt 	= pass.match (/[A-Z]/g),
			chCnt	= pass.match (/[\W_]/g);

		digCnt 	= digCnt ? digCnt.length : 0;
		lcCnt 	= lcCnt ? lcCnt.length : 0;
		ucCnt 	= ucCnt ? ucCnt.length : 0;
		chCnt 	= chCnt ? chCnt.length : 0;

		// LICZBY
		// 1+
		if (digCnt) {
			this.points += 6;
			
			// 2+
			if (digCnt >= 2) {
				this.points += 5;
				
			}
		}

		// LITERY
		// male
		if (lcCnt) {
			this.points += 1;
			
		}
		// wielkie
		if (ucCnt) {
			this.points += 5;
			
		}

		// ZNAKI SPECJALNE
		// 1+
		if (chCnt) {
			this.points += 5;
			
			// 2+
			if (chCnt >= 2) {
				this.points += 6;
			}
		}

		// MIX
		// (litery wielkie && male)
		if (lcCnt && ucCnt) {
			this.points += 2;
		}
		// litery && liczby
		if ((lcCnt || ucCnt) && digCnt) {
			this.points += 2;
		}
		// (litery || cyfry) && specjalne
		if ((lcCnt || ucCnt || digCnt) && chCnt) {
			this.points += 3;
		}

		if (this.points < 0)
			this.level = 0;
		else if (this.points < 15)
			this.level = 1;
		else if (this.points < 25)
			this.level = 2;
		else if (this.points < 35)
			this.level = 3;
		else if (this.points < 45)
			this.level = 4;
		else
			this.level = 5;


}
