/**
 * @author ajnasz@gmail.com
 */
/*
Ajnasz's tagger script v0.3.7
2006. 09. 06.

What's new:
tags array out of init function.
*/

Object.extend(Event, {
    /*
    kiegeszites Event osztalyhoz
    */
    KEY_HOME: 35,
    KEY_END: 36,
    KEY_PAGE_UP: 33,
    KEY_PAGE_DOWN: 34
});

keyhandler = function(e) {
  /*
  handling the keypresses
  depend the keycode run a function or just return true
  
  @e = identifier of the event
  @key = code of pressed key
  @Event.KEY_RETURN add the selected tag
  if not special key, search between the tags
  */
  e = e||window.event;
  var key = e.which || e.keyCode;
  switch (key) {
    case Event.KEY_RETURN:
      addSugToInput(selected(1));
      return true;
      break;
    
    case Event.KEY_DOWN:
      changeFocus.down(1);
      return true;
      break;
      
    case Event.KEY_UP:
      changeFocus.up(1);
      return true;
      break;
    
    case Event.KEY_PAGE_UP:
      changeFocus.up(jump);
      return true;
      break;
    
    case Event.KEY_PAGE_DOWN:
      changeFocus.down(jump);
      return true;
      break;
    
     /*
    case Event.KEY_BACKSPACE:
      return true;
      break;
    */
    /*
    case KEY_HOME:
      changeFocus.home();
      return false;
      break;
      
    case KEY_END: // end
      changeFocus.end();
      return false;
      break;
    */
    /*
    case Event.KEY_LEFT:
      return true;
      break;
      
    case Event.KEY_RIGHT:
      return true;
      break;
    */
    
    default:
      return true;
      break;
  }
}

compare = function() {
  /*
  compare the input filed's values before and after the keypress
  @newCont = global variable, current value of input field
  @oldCont = global variable, set firest on init, then all keypress
  @oldContArr = array from inputs previous value
  @newContArr = array from inputs current value
  */
  newCont = $F(inp).toLowerCase();
  if(newCont == oldCont) {
    oldContArr = oldCont.toLowerCase().split(' ');
    newContArr = $F(inp).toLowerCase().toLowerCase().split(' ');
    oldCont = $F(inp).toLowerCase();
    return true;
  } else {
    oldContArr = oldCont.split(' ');
    newContArr = $F(inp).toLowerCase().split(' ');
    oldCont = $F(inp).toLowerCase();
    return false;
  }
}


tagIsIn = function(tag, arr) {
  /*
  check that the @tag is in the arr Array
  */
  var isIn = 0;
  arr.each(
    function(curTag) {
      if(curTag.toLowerCase() == tag.toLowerCase()) {
        isIn++;
      }
    }
  );
  return isIn;
}

grepKul = function() {
  /*
  filter the difference between the input's current and previous value
  */
  var t = null;
  var tags = new Object;
  for(var i=0; i<newContArr.length; i++) {
    t = newContArr[i]
    isIn = tagIsIn(t, oldContArr);
    if(isIn == 0) {
      var r = new Object;
      r.diff = t;
      r.index = i;
      return r;
    }
    if(tagIsIn(t, newContArr)>1) {
      var r = new Object;
      r.diff = t;
      r.index = i;
      return r;
    }
  }
  
  return false;
}

createSuggestion = function(diff, ts) {
  /*
  create the list of suggested tags
  @regext = difference in regular expression
  @suggestions = array of suggested tags, the function return this
  @ts = tags
  */
  if(diff.diff=='' || !diff) {return false;}
  var regEx = new RegExp('^'+diff.diff, 'i');
  var suggestions = Array();
  
  if(inline || maxSugOutline) {
    for(var i=0; i<ts.length && suggestions.length<maxSug; i++) {
      if(regEx.test(ts[i]) && !tagIsIn(ts[i], oldContArr)) {
        suggestions.push(ts[i]);
      }
    }
  } else {
    ts.each(
      function(val) {
        if(regEx.test(val) && !tagIsIn(val, oldContArr)) { suggestions.push(val); }
      }
    );
  }
  if(suggestions.length == 1 && suggestions[0] == diff.diff) return false;
  if(suggestions.length<1) return false;
  return suggestions;
}

sugsToHTML = function(sugs) {
  /*
  generate html from suggested tags
  @inline = global array, declareted in the init func., set the look of tags
  */
  if(!sugs) { return false; }
  var strSugs = '';
  if(inline) strSugs += '<ul>';
  sugs.each(
    function(sug, index) {
      if(index == 0) {
        if(inline) strSugs +='<li>';
        strSugs += '<a href="javascript:void(0);" class="selected" onclick="addSugToInput(this);">'+sug+'</a>';
        (inline)?strSugs +='</li>':strSugs+=' ';
      } else {
        if(inline) strSugs +='<li>';
        strSugs += '<a href="javascript:void(0);" onclick="addSugToInput(this);">'+sug+'</a>';
        (inline)?strSugs +='</li>':strSugs+=' ';
      }
    }
  );
  if(inline) strSugs +='</ul>';
  return strSugs;
}

dispSug = {
  /*
  show, hide the container object of the suggested tags
  */
  hide: function() {
    Element.update(sug, '');
    Element.hide(sug);
  },
  
  show: function() {
    Element.show(sug);
  }
}


addSugToInput = function(o) {
  /*
  add the selected tag into the input field
  */
  if(!o) return false;
  newContArr[diff.index] = o.innerHTML;
  var vesszReg = new RegExp(',', 'g');
  var ns = newContArr.toString().replace(vesszReg, ' ');
  inp.value = ns;
  delete diff;
  dispSug.hide();
  oldCont = $F(inp).toLowerCase();
  oldContArr = oldCont.split(' ');
}


tagger = function(event){
  /*
  run onkeyup event
  @diff = global variable, difference between after and before keypress state, parameter of addSugToInput
  @sugs = suggestions array
  */
  if(keyhandler(event)) {
    if(!compare()) {
      sug_links = false;
      diff= grepKul();
      var sugs = createSuggestion(diff, tags);
      var sugsInHTML = sugsToHTML(sugs);
      if(!sugsInHTML) { dispSug.hide(); return false; }
      dispSug.show();
      Element.update(sug, sugsInHTML);
      return true;
    }
  } else {
    return false;
  }
}

changeFocus = {
  /*
  change the suggested tags focus, up, down, PageUp, PageDown
  @sug_links = suggested links
  # home, end not used 
  */
  up: function(lines) {
    if(!sug_links) { sug_links = $A(sug.getElementsByTagName('a')); }
    for(var i=0; i<sug_links.length; i++) {
      if(Element.hasClassName(sug_links[i], selClass) && sug_links[i-lines] && i != 0) {
        Element.removeClassName(sug_links[i], selClass);
        Element.addClassName(sug_links[i-lines], selClass);
        return true;
      }
      else if(Element.hasClassName(sug_links[i], selClass) && !sug_links[i-lines] && i != 0){
        Element.removeClassName(sug_links[i], selClass);
        Element.addClassName(sug_links[0], selClass);
        return true;
      }
    }
  },
  
  down: function(lines) {
    if(!sug_links) { sug_links = $A(sug.getElementsByTagName('a')); }
    for(var i=0; i<sug_links.length; i++) {
      if(Element.hasClassName(sug_links[i], selClass) && sug_links[i+lines] && i != sug_links.length-1) {
        Element.removeClassName(sug_links[i], selClass);
        Element.addClassName(sug_links[i+lines], selClass);
        return true;
      }
      else if(Element.hasClassName(sug_links[i], selClass) && !sug_links[i+lines] && i != sug_links.length-1){
        Element.removeClassName(sug_links[i], selClass);
        Element.addClassName(sug_links[sug_links.length-1], selClass);
        return true;
      }
    }
  },
  
  home: function() {
    if(!sug_links) { sug_links = $A(sug.getElementsByTagName('a')); }
    for(var i=0; i<sug_links.length; i++) {
      if(Element.hasClassName(sug_links[i], selClass) && i != sug_links.length-1) {
        Element.removeClassName(sug_links[i], selClass);
        Element.addClassName(sug_links[sug_links.length-1], selClass);
        return true;
      }
    }
  },
  
  end: function() {
    if(!sug_links) { sug_links = $A(sug.getElementsByTagName('a')); }
    for(var i=0; i<sug_links.length; i++) {
      if(Element.hasClassName(sug_links[i], selClass) && i != 0) {
        Element.removeClassName(sug_links[i], selClass);
        Element.addClassName(sug_links[0], selClass);
        return true;
      }
    }
  }
}

selected = function() {
  /*
  return the first suggested tag, which has the selected attrib
  @sug_links = suggested links
  */
  if(!sug_links) { sug_links = $A(sug.getElementsByTagName('a')); }
  for(var i=0; i<sug_links.length; i++) {
    if(Element.hasClassName(sug_links[i], selClass)){ return sug_links[i];}
  }
}

init = function() {
  /*
  initialization function, run when page is loaded
  @inp = global variable, input field object
  @inline = change the look of suggested tags. If true, the suggested tags will be list items
  @maxSugOutline = if true, the suggested tags will maximized when inline false
  @maxSug = maximize the number of the suggested tags
  @jump = number of jumps when you press PageDown or PageUp
  @selClass = Define the class name of the selected tags
  */
  
  // these variables could defined out of the init function
  inline = false;
  selClass = 'selected';
  maxSug = 10;
  maxSugOutline = false;
  jump = 3;
  // ******************************************************
  
  
  inp = $('ize');
  sug = $('sugg');
  tags.sort();
  oldCont = $F(inp).toLowerCase();
  oldContArr = oldCont.split(' ');
  newContArr = $F(inp).toLowerCase().split(' ');
  sug_links = false;
  dispSug.hide();
  Event.observe(inp, 'keyup', tagger, false);
}
Event.observe(window, 'load', init, false);
