// JavaScript Document
/**
 * PortableDrag.js:
 * beginDrag() is designed to be called from an onmousedown event handler.
 * elementResize may be the element that received the mousedown event, or it
 * may be some containing element.  event must be the Event object for the
 * mousedown event.  This implementation works with both the DOM Level 2
 * event model and the IE Event model.
 **/

//resizeBar =

var resizeDiv = document.getElementById('resize_div');

function startResize(resizeBar, event, minWidth){

    if(!resizeDiv){
      resizeDiv  = document.getElementById('resize_div');
    }

    if( !minWidth ){
        minWidth = 10;
    }
    
    //Compute the distance between the upper-left corner of the element
    //and the mouse click. The resMoveHandler function below needs these values.
    var tdToResize = resizeBar.parentNode;
    var parentTable = tdToResize.parentNode;
    
    while(parentTable && parentTable.nodeName != 'TBODY' ){
      parentTable = parentTable.parentNode;
    }
    
    /*
    if(!sasiadl){
      alert('Nie znaleziono elementu DIV z lewej strony!!');
      return false;
    }*/
    
    /**************************************************************************/
    /*var sasiadp = resizeElement.nextSibling;
    while(sasiadp && sasiadp.nodeName != 'DIV' ){
      sasiadp = sasiadp.nextSibling;
    }

    if(!sasiadp){
      alert('Nie znaleziono elementu DIV z prawej strony!!');
      return false;
    }*/

    
    var startX     = event.clientX;

    var startLeft  = parseInt(resizeBar.offsetLeft);
    var startTop   = parseInt(resizeBar.offsetTop);
    
    resizeDiv.style.left = startLeft + 'px';
    resizeDiv.style.top  = startTop  + 'px';
    resizeDiv.style.height = parentTable.offsetHeight + 'px';
    resizeDiv.style.visibility = 'visible';
    
    var startWidth = parseInt( tdToResize.offsetWidth );
    //maksymalna szeroko elementu, teoretycznie
    maxWidth = (parentTable.offsetWidth - tdToResize.offsetLeft - resizeBar.offsetWidth);
    

    window.status = 'x = ' + event.clientX + ', y = ' + event.clientY + ' startLeft = ' + startLeft + ' startTop = ' + startTop + ' h = ' + resizeDiv.style.height;
    

    // Register the event handlers that will respond to the mousemove events
    // and the mouseup event that follow this mousedown event.
    if (document.addEventListener) {  // DOM Level 2 Event Model
        // Register capturing event handlers
        document.addEventListener("mousemove", resMoveHandler, true);
        document.addEventListener("mouseup", resUpHandler, true);
    }
    else if (document.attachEvent) {  // IE 5+ Event Model
        // In the IE Event model, we can't capture events, so these handlers
        // are triggered when only if the event bubbles up to them.
        // This assumes that there aren't any intervening elements that
        // handle the events and stop them from bubbling.
        document.attachEvent("onmousemove", resMoveHandler);
        document.attachEvent("onmouseup", resUpHandler);
    }
    else {                            // IE 4 Event Model
        // In IE 4 we can't use attachEvent(), so assign the event handlers
        // directly after storing any previously assigned handlers so they
        // can be restored.  Note that this also relies on event bubbling.
        var oldmovehandler = document.onmousemove;
        var olduphandler = document.onmouseup;
        document.onmousemove = resMoveHandler;
        document.onmouseup = resUpHandler;
    }

    // We've handled this event.  Don't let anybody else see it.
    if (event.stopPropagation) event.stopPropagation();   // DOM Level 2
    else event.cancelBubble = true;                       // IE

    // Now prevent any default action.
    if (event.preventDefault) event.preventDefault();     // DOM Level 2
    else event.returnValue = false;                       // IE

  /**
  * This is the handler that captures mousemove events when an element
  * is being dragged.  It is responsible for moving the element.
  **/
  function resMoveHandler(e) {
  	if (!e) e = window.event;  // IE event model

    // Move the element to the current mouse position, adjusted as
  	// necessary by the offset of the initial mouse click.
  	var deltaX   = (e.clientX - startX);
  	var newLeft  = startLeft  + deltaX;
  	var newWidth = startWidth + deltaX;
  	
    //window.status =  "clientX = " + e.clientX + "startX  = " + startX + 'newWidth = ' + newWidth;

  	if(newWidth < minWidth){
      resizeDiv.style.left = (tdToResize.offsetLeft + minWidth) + 'px';
      //resizeElement.style.visibility = 'visible';
    }else if( newWidth > maxWidth ){
      resizeDiv.style.left = (parentTable.clientWidth - resizeDiv.clientWidth) + 'px';
      //resizeElement.style.visibility = 'hidden';
    }else{
      resizeDiv.style.left = (newLeft) + 'px';
      //resizeElement.style.visibility = 'visible';
    }
    
  	//resizeElement.style.left = (e.clientX - deltaX) + "px";
  	//resizeElement.style.top = (e.clientY - deltaY) + "px";

  	// And don't let anyone else see this event.
  	if (e.stopPropagation)
      e.stopPropagation();       // DOM Level 2
  	else
      e.cancelBubble = true;                       // IE
  }

  /**
     * This is the handler that captures the final mouseup event that
     * occurs at the end of a drag.
  **/
  function resUpHandler(e) {
  	if (!e) e = window.event;  // IE event model

    resizeDiv.style.visibility = 'hidden';
    resizeDiv.style.left = '0px';
    resizeDiv.style.top = '0px';
    
  	var deltaX   = (e.clientX - startX);
  	var newLeft  = startLeft + deltaX;
  	var newWidth = startWidth + deltaX;

  	//window.status =  "clientX = " + e.clientX + "startX  = " + startX + 'newWidth = ' + newWidth;

  	if(newWidth < minWidth){
      newWidth = minWidth + 'px';
      //resizeElement.style.visibility = 'visible';
    }else if( newWidth > maxWidth ){
      newWidth = maxWidth + 'px';
      //resizeElement.style.visibility = 'hidden';
    }else{
       newWidth =  newWidth + 'px';
      //resizeElement.style.visibility = 'visible';
    }
    
    var col = 0;

    var prevTD = tdToResize;
    while( prevTD ){
      if(prevTD.nodeName == 'TH'){
        col++;
      }
      prevTD = prevTD.previousSibling;
    }

    window.status = "newWidth = " + newWidth + " col = " + col + ' ' + tdToResize.nodeName;
    
    tdToResize.style.width = newWidth;
    
    var nextTR = tdToResize.parentNode.nextSibling;
    var nextTD = null;
    var i = 0;
    while( nextTR ){
      if(nextTR.nodeName == 'TR'){
        //znajdz columne odpowiednia
        nextTD = nextTR.firstChild;
        i = 0;
        
        while( nextTD ){
          if(nextTD.nodeName == 'TD'){
            i++;
            if (i == col) break;
          }
          nextTD = nextTD.nextSibling;
        }

        try{ nextTD.style.width = newWidth; }catch(wyjatek){ /*do nthing */ }
      }
      nextTR = nextTR.nextSibling;
    }
    
    

  	// Unregister the capturing event handlers.
  	if (document.removeEventListener) {    // DOM Event Model
  	    document.removeEventListener("mouseup", resUpHandler, true);
  	    document.removeEventListener("mousemove", resMoveHandler, true);
  	}
  	else if (document.detachEvent) {       // IE 5+ Event Model
  	    document.detachEvent("onmouseup", resUpHandler);
  	    document.detachEvent("onmousemove", resMoveHandler);
  	}
  	else {                                 // IE 4 Event Model
  	    document.onmouseup = olduphandler;
  	    document.onmousemove = oldmovehandler;
  	}

  	// And don't let the event propagate any further.
  	if (e.stopPropagation) e.stopPropagation();       // DOM Level 2
  	else e.cancelBubble = true;                       // IE
  }
}


