CREATE GENERATOR WWW_ZT_POZ_ID_GEN;

CREATE GENERATOR WWW_ZT_ID_GEN;

CREATE GENERATOR WWW_WYRAZY_ID_GEN;

CREATE GENERATOR WWW_SYNONIMY_ID_GEN;

CREATE GENERATOR WWW_STRONY_ID_GEN;

CREATE GENERATOR WWW_SEARCH_HISTORY_ID_GEN;

CREATE GENERATOR WWW_IP_ID_GEN;

CREATE GENERATOR WWW_CONFIG_ID_GEN;

DROP GENERATOR WWW_RABATY_ID_GEN;

DROP GENERATOR WWW_LANG_ID_GEN;

DROP GENERATOR WWW_KUPONY_ID_GEN;

DROP GENERATOR WWW_GRATIS_ID_GEN;

DROP GENERATOR WWW_CHAT_USERS_ID_GEN;

CREATE DOMAIN ADRES_EMAIL_D AS VARCHAR(64) CHARACTER SET WIN1250 COLLATE WIN1250;

CREATE TABLE WWW_ZT_POZ (
  ID ID_D NOT NULL,
  ID_GLOWKI ID_D NOT NULL,
  ID_TOWARU ID_D NOT NULL,
  LP INTEGER,
  SKROT_ORYGINALNY STRING25_D NOT NULL,
  NAZWA_ORYGINALNA STRING250_D NOT NULL,
  SKROT_ALTERNATYWNY STRING25_D NOT NULL,
  NAZWA_ALTERNATYWNA STRING250_D NOT NULL,
  ILOSC_PO ILOSC_D NOT NULL,
  ID_OPAKOWANIA SLOWNIK_D,
  ILOSC_ZAMOWIONYCH_OPAKOWAN ILOSC_NULL_D,
  JEDNOSTKA SLOWNIK_D,
  JEDNOSTKA_ALT SLOWNIK_D,
  WSPOLCZYNNIK_JEDN CENA_D DEFAULT 1 NOT NULL,
  ILOSC_ALT_PO ILOSC_D NOT NULL,
  RODZAJ_RABATU SLOWNIK_D,
  RABAT PROCENT_D NOT NULL,
  ID_STAWKI ID_D NOT NULL,
  STAWKA PROCENT_D NOT NULL,
  RODZAJ_CENY SLOWNIK_D,
  ID_WAL_CENY_KAT ID_D DEFAULT 0 NOT NULL,
  KURS_WAL_CENY_KAT NUMERIC(15, 8) DEFAULT 0,
  CENA_KATALOGOWA CENA_D NOT NULL,
  CENA_SPRZEDAZY CENA_D NOT NULL,
  CENA_SP_WAL_BRUTTO CENA_D NOT NULL,
  CENA_SP_WAL_NETTO CENA_D NOT NULL,
  CENA_SP_PLN_NETTO CENA_D NOT NULL,
  CENA_SP_PLN_BRUTTO CENA_D DEFAULT 0.0000 NOT NULL,
  CENA_SP_WAL_NETTO_ALT CENA_D NOT NULL,
  CENA_SP_WAL_BRUTTO_ALT CENA_D NOT NULL,
  CENA_SP_PLN_NETTO_ALT CENA_D NOT NULL,
  CENA_SP_PLN_BRUTTO_ALT CENA_D DEFAULT 0.0000 NOT NULL,
  WAGA_ZAMOWIONYCH_NETTO ILOSC_D NOT NULL,
  WAGA_ZAMOWIONYCH_BRUTTO ILOSC_D NOT NULL,
  WAGA_ZAMOWIONYCH_OPAKOWAN ILOSC_D NOT NULL,
  UWAGI BLOB);


ALTER TABLE WWW_ZT_POZ ADD CONSTRAINT WWW_ZT_POZ_PK PRIMARY KEY (ID);

ALTER TABLE WWW_ZT_POZ ADD CONSTRAINT WWW_ZT_POZ_ID_OPAKOWANIA_FK FOREIGN KEY (ID_OPAKOWANIA) REFERENCES GM_OPAKOWANIA(ID) ON UPDATE CASCADE;

ALTER TABLE WWW_ZT_POZ ADD CONSTRAINT WWW_ZT_POZ_ID_TOWARU FOREIGN KEY (ID_TOWARU) REFERENCES GM_TOWARY(ID) ON UPDATE CASCADE;

ALTER TABLE WWW_ZT_POZ ADD CONSTRAINT WWW_ZT_POZ_JEDN_ALT_FK FOREIGN KEY (JEDNOSTKA_ALT) REFERENCES GM_MIARY(ID) ON UPDATE CASCADE;

ALTER TABLE WWW_ZT_POZ ADD CONSTRAINT WWW_ZT_POZ_RODZAJCENY_FK FOREIGN KEY (RODZAJ_CENY) REFERENCES GM_CENY(ID) ON UPDATE CASCADE;

ALTER TABLE WWW_ZT_POZ ADD CONSTRAINT WWW_ZT_POZ_RODZAJRABATU_FK FOREIGN KEY (RODZAJ_RABATU) REFERENCES GM_RABATY(ID) ON UPDATE CASCADE;


CREATE INDEX WWW_ZT_POZ_ID_GLOWKI_IND ON WWW_ZT_POZ(ID_GLOWKI);


SET TERM  ^ ;

CREATE TRIGGER WWW_ZT_POZ_BI FOR WWW_ZT_POZ
ACTIVE BEFORE INSERT
POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_ZT_POZ_ID_GEN,1);
END ^

SET TERM ;  ^


CREATE TABLE WWW_ZT (
  ID ID_D NOT NULL,
  MAGNUM ID_D NOT NULL,
  SPOSOB_LICZENIA BLOKADA_D NOT NULL,
  ID_SPOSOBU_PLATNOSCI SLOWNIK_D NOT NULL,
  NAZWA_SPOSOBU_PLATNOSCI STRING100_D NOT NULL,
  TERMIN_PLATNOSCI SMALLINT,
  SP_DOST_USLUGA INTEGER,
  NAZWA_SPOSOBU_DOSTAWY STRING100_D,
  RODZAJ_CENY SLOWNIK_D,
  RODZAJ_RABATU SLOWNIK_D,
  ID_WALUTY ID_D DEFAULT 0 NOT NULL,
  ID_TABELI_KURSOWEJ SLOWNIK_D,
  NUMER_TABELI_KURSOWEJ NUMER_NULL_D,
  KURS NUMERIC(15, 8) DEFAULT 1,
  ID_PLATNIKA ID_D NOT NULL,
  ID_ODBIORCY ID_D NOT NULL,
  NAZWA_SKROCONA_PLATNIKA STRING50_D NOT NULL,
  NIP_PLATNIKA STRING20_D,
  KOD_KRESKOWY_PLATNIKA STRING40_D,
  NAZWA_PELNA_PLATNIKA NAZWA_D NOT NULL,
  ULICA_PLATNIKA STRING50_D,
  NRDOMU_PLATNIKA STRING10_D,
  NRLOKALU_PLATNIKA STRING10_D,
  KOD_PLATNIKA STRING10_D,
  MIEJSCOWOSC_PLATNIKA STRING50_D,
  PANSTWO_PLATNIKA STRING25_D,
  NAZWA_SKROCONA_ODBIORCY STRING50_D NOT NULL,
  NIP_ODBIORCY STRING20_D,
  KOD_KRESKOWY_ODBIORCY STRING40_D,
  NAZWA_PELNA_ODBIORCY NAZWA_D NOT NULL,
  ULICA_ODBIORCY STRING50_D,
  NRDOMU_ODBIORCY STRING10_D,
  NRLOKALU_ODBIORCY STRING10_D,
  KOD_ODBIORCY STRING10_D,
  MIEJSCOWOSC_ODBIORCY STRING50_D,
  PANSTWO_ODBIORCY STRING25_D,
  WAL_WARTOSC_NETTO WARTOSC_D DEFAULT 0 NOT NULL,
  WAL_KWOTA_VAT WARTOSC_D DEFAULT 0 NOT NULL,
  WAL_WARTOSC_BRUTTO WARTOSC_D DEFAULT 0 NOT NULL,
  PLN_WARTOSC_NETTO WARTOSC_D DEFAULT 0 NOT NULL,
  PLN_KWOTA_VAT WARTOSC_D DEFAULT 0.0000 NOT NULL,
  PLN_WARTOSC_BRUTTO WARTOSC_D DEFAULT 0.0000 NOT NULL,
  KOSZT_PRZESYLKI CENA_D NOT NULL,
  KOSZT_PRZESYLKI_BRUTTO CENA_D NOT NULL,
  DATADODANIA DATA_TIME_D DEFAULT CURRENT_DATE NOT NULL,
  GUID GUID_D,
  UWAGI BLOB SUB_TYPE 1 CHARACTER SET WIN1250,
  UWAGI_KLIENTA BLOB SUB_TYPE 1 CHARACTER SET WIN1250,
  ADRES_WYSYLKI BLOB SUB_TYPE 1 CHARACTER SET WIN1250,
  FV_DANE BLOB SUB_TYPE 1 CHARACTER SET WIN1250,
  CONFIRM BOOLEAN_D NOT NULL,
  CONFIRM_DATE TIMESTAMP,
  EMAIL ADRES_EMAIL_D,
  FAKTURA BOOLEAN_D NOT NULL);


ALTER TABLE WWW_ZT ADD CONSTRAINT WWW_ZT_PK PRIMARY KEY (ID);

ALTER TABLE WWW_ZT ADD CONSTRAINT WWW_ZT_ID_ODBIORCY_FK FOREIGN KEY (ID_ODBIORCY) REFERENCES R3_CONTACTS(ID) ON UPDATE CASCADE;

ALTER TABLE WWW_ZT ADD CONSTRAINT WWW_ZT_ID_PLATNIKA_FK FOREIGN KEY (ID_PLATNIKA) REFERENCES R3_CONTACTS(ID) ON UPDATE CASCADE;

ALTER TABLE WWW_ZT ADD CONSTRAINT WWW_ZT_ID_SP_ZAPLATY_FK FOREIGN KEY (ID_SPOSOBU_PLATNOSCI) REFERENCES GM_SPOSOBY_ZAP(ID) ON UPDATE CASCADE;

ALTER TABLE WWW_ZT ADD CONSTRAINT WWW_ZT_MAGNUM_FK FOREIGN KEY (MAGNUM) REFERENCES GM_MAGAZYNY(ID) ON UPDATE CASCADE;

ALTER TABLE WWW_ZT ADD CONSTRAINT WWW_ZT_RODZAJ_CENY_FK FOREIGN KEY (RODZAJ_CENY) REFERENCES GM_CENY(ID) ON UPDATE CASCADE;

ALTER TABLE WWW_ZT ADD CONSTRAINT WWW_ZT_RODZAJ_RABATU_FK FOREIGN KEY (RODZAJ_RABATU) REFERENCES GM_RABATY(ID) ON UPDATE CASCADE;


CREATE INDEX WWW_ZT_GUID_IND ON WWW_ZT(GUID);

CREATE INDEX WWW_ZT_ID_PLATNIKA_IND ON WWW_ZT(ID_PLATNIKA);


SET TERM  ^ ;

CREATE TRIGGER WWW_ZT_BI FOR WWW_ZT
ACTIVE BEFORE INSERT
POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_ZT_ID_GEN,1);
END ^

SET TERM ;  ^


CREATE TABLE WWW_WYRAZY (
  ID INTEGER NOT NULL,
  WYRAZ VARCHAR(64) CHARACTER SET WIN1250 NOT NULL COLLATE PXW_PLK,
  CDATE TIMESTAMP,
  MDATE TIMESTAMP);


ALTER TABLE WWW_WYRAZY ADD CONSTRAINT WWW_WYRAZY_PK PRIMARY KEY (ID);


CREATE INDEX WWW_WYRAZY_DATY_IND ON WWW_WYRAZY(CDATE,MDATE);

CREATE INDEX WWW_WYRAZY_WYRAZ_IND ON WWW_WYRAZY(WYRAZ);

SET TERM  ^ ;

CREATE TRIGGER WWW_WYRAZY_BI FOR WWW_WYRAZY
ACTIVE BEFORE INSERT
POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_WYRAZY_ID_GEN,1);
END ^

SET TERM ;  ^


CREATE TABLE WWW_TOWARY (
  TOWAR_ID INTEGER NOT NULL,
  NAZWA VARCHAR(250) CHARACTER SET WIN1250 NOT NULL COLLATE WIN1250,
  OPIS BLOB SUB_TYPE 1 CHARACTER SET WIN1250,
  KEYWORDS STRING512_D);


ALTER TABLE WWW_TOWARY ADD CONSTRAINT WWW_TOWARY_TOWAR_ID_FK FOREIGN KEY (TOWAR_ID) REFERENCES GM_TOWARY(ID) ON DELETE CASCADE ON UPDATE CASCADE;


CREATE INDEX WWW_TOWARY_NAZWA_IND ON WWW_TOWARY(NAZWA);


CREATE TABLE WWW_SYNONIMY (
  ID INTEGER NOT NULL,
  WYRAZ_ID INTEGER NOT NULL,
  SYNONIM VARCHAR(64) CHARACTER SET WIN1250 NOT NULL COLLATE PXW_PLK);


ALTER TABLE WWW_SYNONIMY ADD CONSTRAINT WWW_SYNONIMY_PK PRIMARY KEY (ID);

ALTER TABLE WWW_SYNONIMY ADD CONSTRAINT WWW_SYNONIMY_WYRAZ_ID_FK FOREIGN KEY (WYRAZ_ID) REFERENCES WWW_WYRAZY(ID) ON DELETE CASCADE ON UPDATE CASCADE;

CREATE UNIQUE INDEX WWW_SYNONIMY_WYRAZ_SYNONIM_UK ON WWW_SYNONIMY(WYRAZ_ID,SYNONIM);


SET TERM  ^ ;

CREATE TRIGGER WWW_SYNONIMY_BI FOR WWW_SYNONIMY
ACTIVE BEFORE INSERT
POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_SYNONIMY_ID_GEN,1);
END ^

SET TERM ;  ^


CREATE TABLE WWW_STRONY (
  ID INTEGER NOT NULL,
  NAZWA VARCHAR(128) CHARACTER SET WIN1250 NOT NULL COLLATE WIN1250,
  TYTUL STRING250_D NOT NULL,
  TRESC BLOB SUB_TYPE 1 SEGMENT SIZE 2048 CHARACTER SET WIN1250,
  CDATE TIMESTAMP NOT NULL,
  MDATE TIMESTAMP NOT NULL);


ALTER TABLE WWW_STRONY ADD CONSTRAINT WWW_STRONY_PK PRIMARY KEY (ID);

ALTER TABLE WWW_STRONY ADD CONSTRAINT WWW_STRONY_NAZWA_UNQ UNIQUE (NAZWA);


CREATE INDEX WWW_STRONY_DATY_IND ON WWW_STRONY(CDATE,MDATE);


SET TERM  ^ ;

CREATE TRIGGER WWW_STRONY_BI FOR WWW_STRONY
ACTIVE BEFORE INSERT
POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_STRONY_ID_GEN,1);
END ^

SET TERM ;  ^


CREATE TABLE WWW_SEARCH_HISTORY (
  ID INTEGER NOT NULL,
  WORD VARCHAR(84) CHARACTER SET WIN1250 NOT NULL COLLATE PXW_PLK,
  SEARCH_COUNT INTEGER NOT NULL,
  FIRST_SEARCH TIMESTAMP NOT NULL,
  LAST_SEARCH TIMESTAMP NOT NULL,
  SEARCH_RESULT BOOLEAN_D NOT NULL);


ALTER TABLE WWW_SEARCH_HISTORY ADD CONSTRAINT WWW_SEARCH_HISTORY_PK PRIMARY KEY (ID);


CREATE INDEX WWW_SEARCH_HISTORY_DATY_IND ON WWW_SEARCH_HISTORY(FIRST_SEARCH,LAST_SEARCH);

CREATE UNIQUE INDEX WWW_SEARCH_HISTORY_WYRAZ_UK ON WWW_SEARCH_HISTORY(WORD);


SET TERM  ^ ;

CREATE TRIGGER WWW_SEARCH_HISTORY_BI FOR WWW_SEARCH_HISTORY
ACTIVE BEFORE INSERT
POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_SEARCH_HISTORY_ID_GEN,1);
END ^

SET TERM ;  ^


CREATE TABLE WWW_IP (
  ID INTEGER NOT NULL,
  ADRES_IP ADRES_IP_D NOT NULL,
  ADMIN_DOSTEP BOOLEAN_D NOT NULL,
  WWW_BLOKADA BOOLEAN_D NOT NULL,
  CDATE TIMESTAMP,
  MDATE TIMESTAMP);


ALTER TABLE WWW_IP ADD CONSTRAINT WWW_IP_PK PRIMARY KEY (ID);

ALTER TABLE WWW_IP ADD CONSTRAINT WWW_IP_ADRES_IP_UNQ UNIQUE (ADRES_IP);


SET TERM  ^ ;

CREATE TRIGGER WWW_IP_BI FOR WWW_IP
ACTIVE BEFORE INSERT
POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_IP_ID_GEN,1);
END ^

SET TERM ;  ^


CREATE TABLE WWW_CONFIG (
  ID INTEGER NOT NULL,
  GRUPA VARCHAR(32) CHARACTER SET WIN1250 NOT NULL COLLATE WIN1250,
  KLUCZ VARCHAR(128) CHARACTER SET WIN1250 NOT NULL COLLATE WIN1250,
  WARTOSC VARCHAR(200) CHARACTER SET WIN1250 COLLATE WIN1250,
  CDATE TIMESTAMP,
  MDATE TIMESTAMP);


ALTER TABLE WWW_CONFIG ADD CONSTRAINT WWW_CONFIG_ID_PK PRIMARY KEY (ID);


CREATE INDEX WWW_CONFIG_DATY_IND ON WWW_CONFIG(CDATE,MDATE);

CREATE UNIQUE INDEX WWW_CONFIG_KLUCZ_GRUPA_UNQ ON WWW_CONFIG(KLUCZ,GRUPA);


SET TERM  ^ ;

CREATE TRIGGER WWW_CONFIG_BI FOR WWW_CONFIG
ACTIVE BEFORE INSERT
POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_CONFIG_ID_GEN,1);
END ^

SET TERM ;  ^


ALTER TABLE WWW_ZK DROP CONSTRAINT PK_WWW_ZK;

ALTER TABLE WWW_REG DROP CONSTRAINT PK_WWW_REG;

ALTER TABLE WWW_ZK ADD PLATNOSC_DATA TIMESTAMP;

ALTER TABLE WWW_ZK ADD PLATNOSC_INFO BLOB SUB_TYPE 2 SEGMENT SIZE 512;

ALTER TABLE WWW_ZK ADD PLATNIK_ID INTEGER;

ALTER TABLE WWW_ZK ADD ODBIORCA_ID INTEGER;

ALTER TABLE WWW_ZK ADD CONTACT_ID INTEGER;

ALTER TABLE WWW_ONLINE ADD USER_AGENT VARCHAR(200) CHARACTER SET WIN1250 COLLATE WIN1250;

ALTER TABLE WWW_GRUPYT ADD OPIS BLOB SUB_TYPE 2 SEGMENT SIZE 512;

ALTER TABLE WWW_GRUPYT ADD PHOTO_FILE VARCHAR(250) CHARACTER SET WIN1250 COLLATE WIN1250;

ALTER TABLE WWW_GRUPYT ADD PHOTO BOOLEAN_D NOT NULL;

update rdb$relation_fields set
rdb$null_flag = NULL
where (rdb$field_name = 'USER_ID')
and (rdb$relation_name = 'WWW_ZK');


update rdb$fields set
rdb$character_set_id = 51
where rdb$field_name = (select rf.rdb$field_source
from rdb$relation_fields rf
where (rf.rdb$field_name = 'ADRES_IP')
and (rf.rdb$relation_name = 'WWW_UWAGI'));

update rdb$fields set
rdb$character_set_id = 51
where rdb$field_name = (select rf.rdb$field_source
from rdb$relation_fields rf
where (rf.rdb$field_name = 'EMAIL')
and (rf.rdb$relation_name = 'WWW_UWAGI'));

update rdb$fields set
rdb$character_set_id = 51
where rdb$field_name = (select rf.rdb$field_source
from rdb$relation_fields rf
where (rf.rdb$field_name = 'PODPIS')
and (rf.rdb$relation_name = 'WWW_UWAGI'));



update rdb$fields set
rdb$character_set_id = 51
where rdb$field_name = (select rf.rdb$field_source
from rdb$relation_fields rf
where (rf.rdb$field_name = 'GUID')
and (rf.rdb$relation_name = 'WWW_REG'));

update rdb$fields set
rdb$character_set_id = 51
where rdb$field_name = (select rf.rdb$field_source
from rdb$relation_fields rf
where (rf.rdb$field_name = 'ADRES_IP')
and (rf.rdb$relation_name = 'WWW_LOG'));


update rdb$fields set
rdb$character_set_id = 51
where rdb$field_name = (select rf.rdb$field_source
from rdb$relation_fields rf
where (rf.rdb$field_name = 'ADRES_IP')
and (rf.rdb$relation_name = 'WWW_KOMENTARZE'));


update rdb$fields set
rdb$character_set_id = 51
where rdb$field_name = (select rf.rdb$field_source
from rdb$relation_fields rf
where (rf.rdb$field_name = 'ADRES_IP')
and (rf.rdb$relation_name = 'WWW_ERRORS'));

update rdb$fields set
rdb$character_set_id = 51
where rdb$field_name = (select rf.rdb$field_source
from rdb$relation_fields rf
where (rf.rdb$field_name = 'PLIK')
and (rf.rdb$relation_name = 'WWW_ERRORS'));

ALTER TABLE WWW_ZK ADD CONSTRAINT WWW_ZK_PLATNIK_ID_FK FOREIGN KEY (PLATNIK_ID) REFERENCES R3_CONTACTS(ID) ON DELETE SET NULL ON UPDATE SET NULL;


ALTER TABLE WWW_ZK ADD CONSTRAINT WWW_ZK_ODBIORCA_ID_FK FOREIGN KEY (ODBIORCA_ID) REFERENCES R3_CONTACTS(ID) ON DELETE SET NULL ON UPDATE SET NULL;


ALTER TABLE WWW_ZK ADD CONSTRAINT WWW_ZK_CONTACT_ID_FK FOREIGN KEY (CONTACT_ID) REFERENCES R3_CONTACTS(ID) ON DELETE SET NULL ON UPDATE SET NULL;


ALTER TABLE WWW_ZK ADD CONSTRAINT WWW_ZK_PK PRIMARY KEY (ID);


ALTER TABLE WWW_REG ADD CONSTRAINT WWW_REG_PK PRIMARY KEY (ID);






/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/


CREATE GENERATOR WWW_HIST_LOGOWANIA_ID_GEN;

CREATE TABLE WWW_HIST_LOGOWANIA (
    ID                INTEGER NOT NULL,
    USER_ID           INTEGER NOT NULL,
    ADRES_IP          ADRES_IP_D NOT NULL /* ADRES_IP_D = VARCHAR(15) DEFAULT '0.0.0.0' */,
    NAZWA_HOSTA       VARCHAR(250) NOT NULL,
    CZAS_LOGOWANIA    TIMESTAMP NOT NULL,
    CZAS_WYLOGOWANIA  TIMESTAMP DEFAULT NULL,
    BLAD              BOOLEAN_D /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    BLEDNE_HASLO      VARCHAR(30) COLLATE PXW_PLK
);




/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_HIST_LOGOWANIA ADD CONSTRAINT WWW_HIST_LOGOWANIA_PK PRIMARY KEY (ID);


/******************************************************************************/
/****                             Foreign Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_HIST_LOGOWANIA ADD CONSTRAINT WWW_HIST_LOGOWANIA_USER_FK FOREIGN KEY (USER_ID) REFERENCES WWW_USERS (ID) ON DELETE CASCADE ON UPDATE CASCADE;


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_HIST_LOGOWANIA_CZASY_IND ON WWW_HIST_LOGOWANIA (CZAS_LOGOWANIA, CZAS_WYLOGOWANIA, BLAD);
CREATE INDEX WWW_HIST_LOGOWANIA_HOST_IND ON WWW_HIST_LOGOWANIA (NAZWA_HOSTA);
CREATE INDEX WWW_HIST_LOGOWANIA_IP_IND ON WWW_HIST_LOGOWANIA (ADRES_IP);


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: WWW_HIST_LOGOWANIA_BI */
CREATE TRIGGER WWW_HIST_LOGOWANIA_BI FOR WWW_HIST_LOGOWANIA
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_HIST_LOGOWANIA_ID_GEN,1);
END
^


SET TERM ; ^



/* Fields descriptions */

DESCRIBE FIELD BLAD TABLE WWW_HIST_LOGOWANIA
'Wzr typu dla pl zawierajcych warto logiczn: tak lub nie';



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT SELECT, INSERT, UPDATE, DELETE ON WWW_HIST_LOGOWANIA TO WWW_ROLE;





/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;




/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/


/* Trigger: WWW_ONLINE_AD0 */
CREATE TRIGGER WWW_ONLINE_AD0 FOR WWW_ONLINE
ACTIVE AFTER DELETE POSITION 0
AS
declare variable HIST_LOG_ID Integer;
begin
  /* Trigger text */
  select first 1 skip 0 ID from www_hist_logowania where user_id = old.user_id and BLAD = 0 and czas_wylogowania is null ORDER BY CZAS_LOGOWANIA INTO :HIST_LOG_ID ;

  if (:HIST_LOG_ID > 0 ) then begin
        update www_hist_logowania set czas_wylogowania = old.last_active where id = :hist_log_id;
  end
end
^

SET TERM ; ^
